package com.ayedroid.bedsideclock;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class settings extends Activity implements B4AActivity{
	public static settings mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.ayedroid.bedsideclock", "com.ayedroid.bedsideclock.settings");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (settings).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "com.ayedroid.bedsideclock", "com.ayedroid.bedsideclock.settings");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "com.ayedroid.bedsideclock.settings", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (settings) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (settings) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return settings.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (settings) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (settings) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ListViewWrapper _scrv = null;
public anywheresoftware.b4a.agraham.dialogs.InputDialog.ColorDialog _picktextcolour = null;
public anywheresoftware.b4a.agraham.dialogs.InputDialog.ColorDialog _pickbgcolour = null;
public anywheresoftware.b4a.agraham.dialogs.InputDialog _picktimeformat = null;
public com.ayedroid.bedsideclock.main _main = null;

public static void initializeProcessGlobals() {
             try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 23;BA.debugLine="scrV.Initialize(\"scrV\")";
mostCurrent._scrv.Initialize(mostCurrent.activityBA,"scrV");
 //BA.debugLineNum = 24;BA.debugLine="Activity.AddView(scrV,0,0,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._scrv.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 25;BA.debugLine="createList";
_createlist();
 //BA.debugLineNum = 26;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 32;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 33;BA.debugLine="saveSettings";
_savesettings();
 //BA.debugLineNum = 34;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 28;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 30;BA.debugLine="End Sub";
return "";
}
public static String  _createlist() throws Exception{
 //BA.debugLineNum = 72;BA.debugLine="Sub createList";
 //BA.debugLineNum = 73;BA.debugLine="pickTextColour.Red = Main.savedSettings.Get(\"clockColourR\")";
mostCurrent._picktextcolour.setRed((int)(BA.ObjectToNumber(mostCurrent._main._savedsettings.Get((Object)("clockColourR")))));
 //BA.debugLineNum = 74;BA.debugLine="pickTextColour.Green = Main.savedSettings.Get(\"clockColourG\")";
mostCurrent._picktextcolour.setGreen((int)(BA.ObjectToNumber(mostCurrent._main._savedsettings.Get((Object)("clockColourG")))));
 //BA.debugLineNum = 75;BA.debugLine="pickTextColour.Blue = Main.savedSettings.Get(\"clockColourB\")";
mostCurrent._picktextcolour.setBlue((int)(BA.ObjectToNumber(mostCurrent._main._savedsettings.Get((Object)("clockColourB")))));
 //BA.debugLineNum = 77;BA.debugLine="pickBgColour.Red = Main.savedSettings.Get(\"bgColourR\")";
mostCurrent._pickbgcolour.setRed((int)(BA.ObjectToNumber(mostCurrent._main._savedsettings.Get((Object)("bgColourR")))));
 //BA.debugLineNum = 78;BA.debugLine="pickBgColour.Green = Main.savedSettings.Get(\"bgColourG\")";
mostCurrent._pickbgcolour.setGreen((int)(BA.ObjectToNumber(mostCurrent._main._savedsettings.Get((Object)("bgColourG")))));
 //BA.debugLineNum = 79;BA.debugLine="pickBgColour.Blue = Main.savedSettings.Get(\"bgColourB\")";
mostCurrent._pickbgcolour.setBlue((int)(BA.ObjectToNumber(mostCurrent._main._savedsettings.Get((Object)("bgColourB")))));
 //BA.debugLineNum = 81;BA.debugLine="pickTimeFormat.Input = Main.savedSettings.Get(\"timeFormat\")";
mostCurrent._picktimeformat.setInput(BA.ObjectToString(mostCurrent._main._savedsettings.Get((Object)("timeFormat"))));
 //BA.debugLineNum = 83;BA.debugLine="scrV.Clear";
mostCurrent._scrv.Clear();
 //BA.debugLineNum = 84;BA.debugLine="scrV.AddTwoLines(\"Clock Colour\",\"R: \"&Main.savedSettings.Get(\"clockColourR\")&\" G: \"&Main.savedSettings.Get(\"clockColourG\")&\" B: \"&Main.savedSettings.Get(\"clockColourB\"))";
mostCurrent._scrv.AddTwoLines("Clock Colour","R: "+BA.ObjectToString(mostCurrent._main._savedsettings.Get((Object)("clockColourR")))+" G: "+BA.ObjectToString(mostCurrent._main._savedsettings.Get((Object)("clockColourG")))+" B: "+BA.ObjectToString(mostCurrent._main._savedsettings.Get((Object)("clockColourB"))));
 //BA.debugLineNum = 85;BA.debugLine="scrV.AddTwoLines(\"Clock Transparency\",Main.savedSettings.Get(\"textTrans\")&\"%\")";
mostCurrent._scrv.AddTwoLines("Clock Transparency",BA.ObjectToString(mostCurrent._main._savedsettings.Get((Object)("textTrans")))+"%");
 //BA.debugLineNum = 86;BA.debugLine="scrV.AddTwoLines(\"Background Colour\",\"R: \"&Main.savedSettings.Get(\"bgColourR\")&\" G: \"&Main.savedSettings.Get(\"bgColourG\")&\" B: \"&Main.savedSettings.Get(\"bgColourB\"))";
mostCurrent._scrv.AddTwoLines("Background Colour","R: "+BA.ObjectToString(mostCurrent._main._savedsettings.Get((Object)("bgColourR")))+" G: "+BA.ObjectToString(mostCurrent._main._savedsettings.Get((Object)("bgColourG")))+" B: "+BA.ObjectToString(mostCurrent._main._savedsettings.Get((Object)("bgColourB"))));
 //BA.debugLineNum = 87;BA.debugLine="scrV.AddTwoLines(\"Time Format\",Main.savedSettings.Get(\"timeFormat\"))";
mostCurrent._scrv.AddTwoLines("Time Format",BA.ObjectToString(mostCurrent._main._savedsettings.Get((Object)("timeFormat"))));
 //BA.debugLineNum = 88;BA.debugLine="scrV.AddTwoLines(\"Save Settings\",\"Save and exit\")";
mostCurrent._scrv.AddTwoLines("Save Settings","Save and exit");
 //BA.debugLineNum = 89;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 13;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 16;BA.debugLine="Dim scrV As ListView";
mostCurrent._scrv = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 17;BA.debugLine="Dim pickTextColour As ColorDialog";
mostCurrent._picktextcolour = new anywheresoftware.b4a.agraham.dialogs.InputDialog.ColorDialog();
 //BA.debugLineNum = 18;BA.debugLine="Dim pickBgColour As ColorDialog";
mostCurrent._pickbgcolour = new anywheresoftware.b4a.agraham.dialogs.InputDialog.ColorDialog();
 //BA.debugLineNum = 19;BA.debugLine="Dim pickTimeFormat As InputDialog";
mostCurrent._picktimeformat = new anywheresoftware.b4a.agraham.dialogs.InputDialog();
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 7;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 11;BA.debugLine="End Sub";
return "";
}
public static String  _savesettings() throws Exception{
 //BA.debugLineNum = 91;BA.debugLine="Sub saveSettings";
 //BA.debugLineNum = 92;BA.debugLine="File.WriteMap(File.DirInternal,\"settings.set\",Main.savedSettings)";
anywheresoftware.b4a.keywords.Common.File.WriteMap(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"settings.set",mostCurrent._main._savedsettings);
 //BA.debugLineNum = 93;BA.debugLine="End Sub";
return "";
}
public static String  _scrv_itemclick(int _position,Object _value) throws Exception{
String[] _lst = null;
int _res = 0;
 //BA.debugLineNum = 36;BA.debugLine="Sub scrV_ItemClick (Position As Int, Value As Object)";
 //BA.debugLineNum = 37;BA.debugLine="Select Position";
switch (_position) {
case 0:
 //BA.debugLineNum = 39;BA.debugLine="If pickTextColour.Show(\"Clock Colour\",\"Done\",\"Cancel\",\"\",Null) = DialogResponse.POSITIVE Then";
if (mostCurrent._picktextcolour.Show("Clock Colour","Done","Cancel","",mostCurrent.activityBA,(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null))==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
 //BA.debugLineNum = 40;BA.debugLine="Main.savedSettings.Put(\"clockColourR\",pickTextColour.Red)";
mostCurrent._main._savedsettings.Put((Object)("clockColourR"),(Object)(mostCurrent._picktextcolour.getRed()));
 //BA.debugLineNum = 41;BA.debugLine="Main.savedSettings.Put(\"clockColourG\",pickTextColour.Green)";
mostCurrent._main._savedsettings.Put((Object)("clockColourG"),(Object)(mostCurrent._picktextcolour.getGreen()));
 //BA.debugLineNum = 42;BA.debugLine="Main.savedSettings.Put(\"clockColourB\",pickTextColour.Blue)";
mostCurrent._main._savedsettings.Put((Object)("clockColourB"),(Object)(mostCurrent._picktextcolour.getBlue()));
 };
 break;
case 1:
 //BA.debugLineNum = 45;BA.debugLine="Dim lst() As String : lst = Array As String(\"100%\",\"80%\",\"60%\",\"40%\",\"20%\")";
_lst = new String[(int) (0)];
java.util.Arrays.fill(_lst,"");
 //BA.debugLineNum = 45;BA.debugLine="Dim lst() As String : lst = Array As String(\"100%\",\"80%\",\"60%\",\"40%\",\"20%\")";
_lst = new String[]{"100%","80%","60%","40%","20%"};
 //BA.debugLineNum = 46;BA.debugLine="Dim res As Int";
_res = 0;
 //BA.debugLineNum = 47;BA.debugLine="res = InputList(lst,\"Clock Transparency\",-1)";
_res = anywheresoftware.b4a.keywords.Common.InputList(anywheresoftware.b4a.keywords.Common.ArrayToList(_lst),"Clock Transparency",(int) (-1),mostCurrent.activityBA);
 //BA.debugLineNum = 48;BA.debugLine="Main.savedSettings.Put(\"textTrans\",lst(res).Replace(\"%\",\"\"))";
mostCurrent._main._savedsettings.Put((Object)("textTrans"),(Object)(_lst[_res].replace("%","")));
 break;
case 2:
 //BA.debugLineNum = 50;BA.debugLine="If pickBgColour.Show(\"Background Colour\",\"Done\",\"Cancel\",\"\",Null) = DialogResponse.POSITIVE Then";
if (mostCurrent._pickbgcolour.Show("Background Colour","Done","Cancel","",mostCurrent.activityBA,(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null))==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
 //BA.debugLineNum = 51;BA.debugLine="Main.savedSettings.Put(\"bgColourR\",pickBgColour.Red)";
mostCurrent._main._savedsettings.Put((Object)("bgColourR"),(Object)(mostCurrent._pickbgcolour.getRed()));
 //BA.debugLineNum = 52;BA.debugLine="Main.savedSettings.Put(\"bgColourG\",pickBgColour.Green)";
mostCurrent._main._savedsettings.Put((Object)("bgColourG"),(Object)(mostCurrent._pickbgcolour.getGreen()));
 //BA.debugLineNum = 53;BA.debugLine="Main.savedSettings.Put(\"bgColourB\",pickBgColour.Blue)";
mostCurrent._main._savedsettings.Put((Object)("bgColourB"),(Object)(mostCurrent._pickbgcolour.getBlue()));
 };
 break;
case 3:
 //BA.debugLineNum = 56;BA.debugLine="If pickTimeFormat.Show(\"HH = hour (24hr), h = hour (12hr), mm = minutes, ss = seconds, a = am/pm marker\",\"Time Format\",\"Done\",\"Cancel\",\"\",Null) = DialogResponse.POSITIVE Then";
if (mostCurrent._picktimeformat.Show("HH = hour (24hr), h = hour (12hr), mm = minutes, ss = seconds, a = am/pm marker","Time Format","Done","Cancel","",mostCurrent.activityBA,(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null))==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
 //BA.debugLineNum = 57;BA.debugLine="Try";
try { //BA.debugLineNum = 58;BA.debugLine="DateTime.TimeFormat = pickTimeFormat.Input";
anywheresoftware.b4a.keywords.Common.DateTime.setTimeFormat(mostCurrent._picktimeformat.getInput());
 } 
       catch (Exception e43) {
			processBA.setLastException(e43); //BA.debugLineNum = 60;BA.debugLine="ToastMessageShow(\"Invalid time format. Please read the instructions.\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Invalid time format. Please read the instructions.",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 61;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 63;BA.debugLine="Main.savedSettings.Put(\"timeFormat\",pickTimeFormat.Input)";
mostCurrent._main._savedsettings.Put((Object)("timeFormat"),(Object)(mostCurrent._picktimeformat.getInput()));
 };
 break;
case 4:
 //BA.debugLineNum = 66;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 break;
}
;
 //BA.debugLineNum = 68;BA.debugLine="saveSettings";
_savesettings();
 //BA.debugLineNum = 69;BA.debugLine="createList";
_createlist();
 //BA.debugLineNum = 70;BA.debugLine="End Sub";
return "";
}
}
