package com.ayedroid.bedsideclock;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "com.ayedroid.bedsideclock", "com.ayedroid.bedsideclock.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "com.ayedroid.bedsideclock", "com.ayedroid.bedsideclock.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "com.ayedroid.bedsideclock.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Timer _tmrupdate = null;
public static anywheresoftware.b4a.objects.collections.Map _savedsettings = null;
public static anywheresoftware.b4a.objects.Timer _tmrsave = null;
public anywheresoftware.b4a.keywords.constants.TypefaceWrapper _lcdfont = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbltime = null;
public anywheresoftware.b4a.phone.Phone _p = null;
public anywheresoftware.b4a.phone.Phone.PhoneWakeState _awake = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnltouch = null;
public static float _prevx = 0f;
public com.ayedroid.bedsideclock.settings _settings = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
vis = vis | (settings.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 61;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 62;BA.debugLine="Activity.Title = \"Complete Clock App - Bermz ISWare Solution\"";
mostCurrent._activity.setTitle((Object)("Complete Clock App - Bermz ISWare Solution"));
 //BA.debugLineNum = 63;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 71;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 72;BA.debugLine="awake.ReleaseKeepAlive";
mostCurrent._awake.ReleaseKeepAlive();
 //BA.debugLineNum = 73;BA.debugLine="tmrUpdate.Enabled = False";
_tmrupdate.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 74;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 65;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 66;BA.debugLine="awake.KeepAlive(False)";
mostCurrent._awake.KeepAlive(processBA,anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 67;BA.debugLine="loadSettings";
_loadsettings();
 //BA.debugLineNum = 68;BA.debugLine="tmrUpdate.Enabled = True";
_tmrupdate.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 69;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
settings._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 20;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 21;BA.debugLine="Dim lcdFont As Typeface";
mostCurrent._lcdfont = new anywheresoftware.b4a.keywords.constants.TypefaceWrapper();
 //BA.debugLineNum = 22;BA.debugLine="lcdFont = lcdFont.LoadFromAssets(\"LCN.otf\")";
mostCurrent._lcdfont.setObject((android.graphics.Typeface)(mostCurrent._lcdfont.LoadFromAssets("LCN.otf")));
 //BA.debugLineNum = 23;BA.debugLine="Dim lblTime As Label";
mostCurrent._lbltime = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 24;BA.debugLine="lblTime.Initialize(\"lblTime\")";
mostCurrent._lbltime.Initialize(mostCurrent.activityBA,"lblTime");
 //BA.debugLineNum = 25;BA.debugLine="lblTime.Typeface = lcdFont";
mostCurrent._lbltime.setTypeface((android.graphics.Typeface)(mostCurrent._lcdfont.getObject()));
 //BA.debugLineNum = 26;BA.debugLine="Activity.AddView(lblTime,0,0,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._lbltime.getObject()),(int) (0),(int) (0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 27;BA.debugLine="lblTime.TextSize = 150";
mostCurrent._lbltime.setTextSize((float) (150));
 //BA.debugLineNum = 28;BA.debugLine="lblTime.Gravity = Gravity.CENTER";
mostCurrent._lbltime.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER);
 //BA.debugLineNum = 29;BA.debugLine="Dim p As Phone";
mostCurrent._p = new anywheresoftware.b4a.phone.Phone();
 //BA.debugLineNum = 30;BA.debugLine="p.SetScreenBrightness(1/100)";
mostCurrent._p.SetScreenBrightness(processBA,(float) (1/(double)100));
 //BA.debugLineNum = 31;BA.debugLine="Dim awake As PhoneWakeState";
mostCurrent._awake = new anywheresoftware.b4a.phone.Phone.PhoneWakeState();
 //BA.debugLineNum = 32;BA.debugLine="Dim pnlTouch As Panel";
mostCurrent._pnltouch = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 33;BA.debugLine="pnlTouch.Initialize(\"pnlTouch\")";
mostCurrent._pnltouch.Initialize(mostCurrent.activityBA,"pnlTouch");
 //BA.debugLineNum = 34;BA.debugLine="Activity.AddView(pnlTouch,0,100%y-50dip,100%x,50dip)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._pnltouch.getObject()),(int) (0),(int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)-anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50))),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50)));
 //BA.debugLineNum = 35;BA.debugLine="Dim prevX As Float : prevX = 50%x";
_prevx = 0f;
 //BA.debugLineNum = 35;BA.debugLine="Dim prevX As Float : prevX = 50%x";
_prevx = (float) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA));
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _lbltime_click() throws Exception{
 //BA.debugLineNum = 80;BA.debugLine="Sub lblTime_Click";
 //BA.debugLineNum = 81;BA.debugLine="StartActivity(\"settings\")";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)("settings"));
 //BA.debugLineNum = 82;BA.debugLine="End Sub";
return "";
}
public static String  _loadsettings() throws Exception{
 //BA.debugLineNum = 84;BA.debugLine="Sub loadSettings";
 //BA.debugLineNum = 85;BA.debugLine="If File.Exists(File.DirInternal,\"settings.set\") Then";
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"settings.set")) { 
 //BA.debugLineNum = 86;BA.debugLine="savedSettings = File.ReadMap(File.DirInternal,\"settings.set\")";
_savedsettings = anywheresoftware.b4a.keywords.Common.File.ReadMap(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"settings.set");
 }else {
 //BA.debugLineNum = 88;BA.debugLine="savedSettings.Put(\"clockColourR\",255)";
_savedsettings.Put((Object)("clockColourR"),(Object)(255));
 //BA.debugLineNum = 89;BA.debugLine="savedSettings.Put(\"clockColourG\",255)";
_savedsettings.Put((Object)("clockColourG"),(Object)(255));
 //BA.debugLineNum = 90;BA.debugLine="savedSettings.Put(\"clockColourB\",255)";
_savedsettings.Put((Object)("clockColourB"),(Object)(255));
 //BA.debugLineNum = 91;BA.debugLine="savedSettings.Put(\"bgColourR\",0)";
_savedsettings.Put((Object)("bgColourR"),(Object)(0));
 //BA.debugLineNum = 92;BA.debugLine="savedSettings.Put(\"bgColourG\",0)";
_savedsettings.Put((Object)("bgColourG"),(Object)(0));
 //BA.debugLineNum = 93;BA.debugLine="savedSettings.Put(\"bgColourB\",0)";
_savedsettings.Put((Object)("bgColourB"),(Object)(0));
 //BA.debugLineNum = 94;BA.debugLine="savedSettings.Put(\"textTrans\",100)";
_savedsettings.Put((Object)("textTrans"),(Object)(100));
 //BA.debugLineNum = 95;BA.debugLine="savedSettings.Put(\"timeFormat\",\"HH:mm:ss\")";
_savedsettings.Put((Object)("timeFormat"),(Object)("HH:mm:ss"));
 //BA.debugLineNum = 96;BA.debugLine="savedSettings.Put(\"textSize\",100)";
_savedsettings.Put((Object)("textSize"),(Object)(100));
 };
 //BA.debugLineNum = 99;BA.debugLine="lblTime.TextColor = Colors.ARGB(savedSettings.Get(\"textTrans\"),savedSettings.Get(\"clockColourR\"),savedSettings.Get(\"clockColourG\"),savedSettings.Get(\"clockColourB\"))";
mostCurrent._lbltime.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.ARGB((int)(BA.ObjectToNumber(_savedsettings.Get((Object)("textTrans")))),(int)(BA.ObjectToNumber(_savedsettings.Get((Object)("clockColourR")))),(int)(BA.ObjectToNumber(_savedsettings.Get((Object)("clockColourG")))),(int)(BA.ObjectToNumber(_savedsettings.Get((Object)("clockColourB"))))));
 //BA.debugLineNum = 100;BA.debugLine="Activity.Color = Colors.RGB(savedSettings.Get(\"bgColourR\"),savedSettings.Get(\"bgColourG\"),savedSettings.Get(\"bgColourB\"))";
mostCurrent._activity.setColor(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(BA.ObjectToNumber(_savedsettings.Get((Object)("bgColourR")))),(int)(BA.ObjectToNumber(_savedsettings.Get((Object)("bgColourG")))),(int)(BA.ObjectToNumber(_savedsettings.Get((Object)("bgColourB"))))));
 //BA.debugLineNum = 101;BA.debugLine="DateTime.TimeFormat = savedSettings.Get(\"timeFormat\")";
anywheresoftware.b4a.keywords.Common.DateTime.setTimeFormat(BA.ObjectToString(_savedsettings.Get((Object)("timeFormat"))));
 //BA.debugLineNum = 102;BA.debugLine="lblTime.TextSize = savedSettings.Get(\"textSize\")";
mostCurrent._lbltime.setTextSize((float)(BA.ObjectToNumber(_savedsettings.Get((Object)("textSize")))));
 //BA.debugLineNum = 103;BA.debugLine="End Sub";
return "";
}
public static String  _pnltouch_touch(int _action,float _x,float _y) throws Exception{
 //BA.debugLineNum = 45;BA.debugLine="Sub pnlTouch_Touch (Action As Int, X As Float, Y As Float)";
 //BA.debugLineNum = 46;BA.debugLine="tmrSave.Enabled = False";
_tmrsave.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 47;BA.debugLine="If lblTime.TextSize - 2 <0 Then";
if (mostCurrent._lbltime.getTextSize()-2<0) { 
 //BA.debugLineNum = 48;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 50;BA.debugLine="If prevX > X Then";
if (_prevx>_x) { 
 //BA.debugLineNum = 51;BA.debugLine="lblTime.TextSize = lblTime.TextSize - 2";
mostCurrent._lbltime.setTextSize((float) (mostCurrent._lbltime.getTextSize()-2));
 };
 //BA.debugLineNum = 53;BA.debugLine="If prevX < X Then";
if (_prevx<_x) { 
 //BA.debugLineNum = 54;BA.debugLine="lblTime.TextSize = lblTime.TextSize + 2";
mostCurrent._lbltime.setTextSize((float) (mostCurrent._lbltime.getTextSize()+2));
 };
 //BA.debugLineNum = 56;BA.debugLine="savedSettings.Put(\"textSize\",lblTime.TextSize)";
_savedsettings.Put((Object)("textSize"),(Object)(mostCurrent._lbltime.getTextSize()));
 //BA.debugLineNum = 57;BA.debugLine="prevX = X";
_prevx = _x;
 //BA.debugLineNum = 58;BA.debugLine="tmrSave.Enabled = True";
_tmrsave.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 59;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 11;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 12;BA.debugLine="Dim tmrUpdate As Timer";
_tmrupdate = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 13;BA.debugLine="tmrUpdate.Initialize(\"tmrUpdate\",\"1000\")";
_tmrupdate.Initialize(processBA,"tmrUpdate",(long)(Double.parseDouble("1000")));
 //BA.debugLineNum = 14;BA.debugLine="Dim savedSettings As Map";
_savedsettings = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 15;BA.debugLine="savedSettings.Initialize";
_savedsettings.Initialize();
 //BA.debugLineNum = 16;BA.debugLine="Dim tmrSave As Timer";
_tmrsave = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 17;BA.debugLine="tmrSave.Initialize(\"tmrSave\",4000)";
_tmrsave.Initialize(processBA,"tmrSave",(long) (4000));
 //BA.debugLineNum = 18;BA.debugLine="End Sub";
return "";
}
public static String  _tmrsave_tick() throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub tmrSave_Tick";
 //BA.debugLineNum = 39;BA.debugLine="tmrSave.Enabled = False";
_tmrsave.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 40;BA.debugLine="If Msgbox2(\"Do you want to save new font size?\",\"New font size\",\"Yes\",\"No\",\"\",Null) = DialogResponse.POSITIVE Then";
if (anywheresoftware.b4a.keywords.Common.Msgbox2("Do you want to save new font size?","New font size","Yes","No","",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null),mostCurrent.activityBA)==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
 //BA.debugLineNum = 41;BA.debugLine="File.WriteMap(File.DirInternal,\"settings.set\",savedSettings)";
anywheresoftware.b4a.keywords.Common.File.WriteMap(anywheresoftware.b4a.keywords.Common.File.getDirInternal(),"settings.set",_savedsettings);
 };
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
public static String  _tmrupdate_tick() throws Exception{
 //BA.debugLineNum = 76;BA.debugLine="Sub tmrUpdate_Tick";
 //BA.debugLineNum = 77;BA.debugLine="lblTime.Text = DateTime.time(DateTime.Now)";
mostCurrent._lbltime.setText((Object)(anywheresoftware.b4a.keywords.Common.DateTime.Time(anywheresoftware.b4a.keywords.Common.DateTime.getNow())));
 //BA.debugLineNum = 78;BA.debugLine="End Sub";
return "";
}
}
